<?php
/* --------------------------------------------------------------
   DataCache.inc.php 2010-11-16 gm
   Gambio GmbH
   http://www.gambio.de
   Copyright (c) 2010 Gambio GmbH
   Released under the GNU General Public License (Version 2)
   [http://www.gnu.org/licenses/gpl-2.0.html]
   --------------------------------------------------------------
*/

class DataCache
{
	var $v_cache_content_array = array();
	var $v_coo_error_log = NULL;

	/*
	* constructor
	*/
	function DataCache()
	{
		if (is_object($GLOBALS['coo_debugger']))
			$GLOBALS['coo_debugger']->log('DataCache() by '.gm_get_env_info('REQUEST_URI'), 'DataCache');
	}

	function &get_instance()
	{
		static $s_instance;

		if($s_instance === NULL)   {
			$s_instance = new DataCache();
		}
		return $s_instance;
	}


	function set_data($p_key, $p_value)
	{
		$this->v_cache_content_array[$p_key] = $p_value;
		if (is_object($GLOBALS['coo_debugger']))
			$GLOBALS['coo_debugger']->log("new content with key ". $p_key, 'DataCache');
	}

	function get_data($p_key)
	{
		$t_output = false;

		if($this->key_exists($p_key) == false)
		{
			# need existing key, so trigger error
			trigger_error('key not found in DataCache', E_USER_ERROR);
		}
		else {
			# key found, return cached data
			$t_output = $this->v_cache_content_array[$p_key];
			if (is_object($GLOBALS['coo_debugger']))
				$GLOBALS['coo_debugger']->log("cached content returned with key ". $p_key, 'DataCache');
		}
		return $t_output;
	}

	function key_exists($p_key)
	{
		$t_output = false;
		
		if(isset($this->v_cache_content_array[$p_key]) == true)
		{
			# key found. return true
			$t_output = true;
		}
		return $t_output;
	}

	function build_key($p_data)
	{
		$t_output = '';
		$t_output = md5($p_data);

		return $t_output;
	}


}
?>
